unit Unit1;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  mTurtle2, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    PaintBox1: TPaintBox;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
    Turtle1 : TTurtle;
    procedure Rechteck(a, b : Double);
    procedure haus(h,g: Double);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Rechteck(a, b: Double);
  begin
  With Turtle1 do begin
    PD;
    FD(a); RT(90);
    FD(b); RT(90);
    FD(a); RT(90);
    FD(b); RT(90);
    PU;
    end;
  end;

procedure TForm1.FormCreate(Sender: TObject);
  begin
  Turtle1 := TTurtle.Create(PaintBox1);
  end;

procedure TForm1.FormResize(Sender: TObject);
  begin
  Turtle1.Resize;
  end;

procedure TForm1.Haus(h, g: Double);
  begin
  With Turtle1 do begin
    LineWidth:=3;
    Color:=clblack;
    Rechteck(h, g);
    RT(90); FD(g/5);
    LT(90); Rechteck(2*h/7, g/5);
    FD(3*h/7); Rechteck(h/7, g/5);
    FD(2*h/7); Rechteck(h/7, g/5);
    FD(h/7); RT(90); FD(3*g/5);
    RT(90); Rechteck(h/7, g/5);
    FD(2*h/7); Rechteck(h/7, g/5);
    FD(2*h/7); Rechteck(h/7, g/5);
    FD(2*h/7); LT(90);
    FD(g/5); LT(90);
    end;
  end;

procedure TForm1.Button1Click(Sender: TObject);
  var a, b, i: integer;
  begin
  With Turtle1 do begin
    CS;
    Home;
    PU;
    BK(Height*2/5);
    LT(90);
    FD(Width*2/5);
    RT(90);
    end;
  b := 40 + Random(40);
  i := b;
  While i < 0.85 * Turtle1.Width do begin
    a := b*2 + Random(3*b);
    Haus(a, b);
    b := 40 + Random(40);
    i := i + b;
    end;
  Turtle1.HT;
  end;

end.
